/*
    Look at the assembly language listing and the obj file
    for this program to get a sense of how the C compiler
    handles all of these different kinds of variables.

    You cannot link or run this program because of the
    unresolved external references.
*/

extern int x;         // external global variable
static int y1;        // static global variable (uninitialized)
static int y2 = 100;  // static global variable (initialized)
       int z1;        // global variable (uninitialized)
       int z2 = 200;  // global variable (initialized)

extern int functionA(int n);  // external function

int functionB(int n)          // global function
{
   extern int xB;         // external local varible (?)
   static int y1B;        // static local variable (uninitialized)
   static int y2B = 300;  // static local variable (initialized)
          int z1B;        // automatic local variable (uninitialized)
          int z2B = 400;  // automatic local variable (initialized)

   functionA(y1B); // call the external function
   functionA(y2B);
   functionA(z1B);
   functionA(z2B);
   functionA(xB);
   return n;
}

int main()
{
   functionA(y1); // call the external function
   functionB(y2); // call the global function
   functionB(z1); // call the global function
   functionB(z2); // call the global function
   functionB(x);  // call the global function

   return 0;
}
